// file: $isip/class/algo/Calculus/calc_01.cc
// version: $Id: calc_01.cc,v 1.6 2001/11/27 19:35:53 gao Exp $
//

// isip include files
//
#include "Calculus.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean Calculus::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;
 
  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();
  
  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                  ALGO_MAP.getName((long)algorithm_d));
  Console::put(output);
  
  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((long)implementation_d));
  Console::put(output);
  
  // display the order
  //
  value.assign((long)order_d);
  output.debugStr(name(), msg_a, L"order_d", value);
  Console::put(output);

  // display delta_win
  //
  value.assign((long)delta_win_d);
  output.debugStr(name(), msg_a, L"delta_win_d", value);
  Console::put(output);

  // display the denominator scale factor
  //
  value.assign((double)denom_d);
  output.debugStr(name(), msg_a, L"denom_d", value);
  Console::put(output);

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");

  // decrease indention
  //
  Console::decreaseIndention();
 
  // exit gracefully
  //
  return true;
}
