// file: $isip/class/algo/Prediction/pred_01.cc
// version: $Id: pred_01.cc,v 1.3 2002/02/06 03:16:49 zheng Exp $
//

// isip include files
//
#include "Prediction.h"
#include <String.h>
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean Prediction::debug(const unichar* msg_a) const {

  // declare local variables
  //  
  String value;
  String output;
  String empty_str;

  // output the information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);

  // increase the indentation
  //  
  Console::increaseIndention();
  
  // display the order
  //
  value.assign(order_d);
  output.debugStr(name(), empty_str, L"order_d", value);
  Console::put(output);
  
  // display the algorithm name
  //
  output.debugStr(name(), empty_str, L"algorithm_d",
                  Prediction::ALGO_MAP.getName((long)algorithm_d));
  Console::put(output);
  
  // display the implementation name
  //
  output.debugStr(name(), empty_str, L"implementation_d",
                  Prediction::IMPL_MAP.getName((long)implementation_d));
  Console::put(output);
  
  // display the dynamic range threshold
  //
  value.assign(dyn_range_d);
  output.debugStr(name(), empty_str, L"dyn_range_d", value);
  Console::put(output);

  // debug level
  //
  output.debugStr(name(), msg_a, L"debug_level_d",
		  debug_level_d.getName());
  Console::put(output);

  // decrease indention
  //
  Console::decreaseIndention();
  
  // exit gracefully
  //
  return true;
}



