// file: $isip/class/algo/Spectrum/spec_01.cc
// version: $Id: spec_01.cc,v 1.7 2002/01/31 21:43:01 zheng Exp $
//

// isip include files
//
#include <Console.h>
#include "Spectrum.h"

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean Spectrum::debug(const unichar* msg_a) const {

  // declare local variables
  //  
  String output;
  String value;
  
  // output the information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
		  ALGO_MAP.getName((long)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((long)implementation_d));
  Console::put(output);

  // display the dynamic range threshold
  //
  value.assign(dyn_range_d);
  output.debugStr(name(), msg_a, L"dyn_range_d", value);
  Console::put(output);
  
  // display the FourierTransform object
  //
  ft_d.debug(L"");

  // display the debug level
  //
  value.assign((long) debug_level_d);
  output.debugStr(name(), msg_a, L"debug_level_d", value);
  Console::put(output);

  // display the base class
  //
  AlgorithmBase::debug(L"AlgorithmBase");
  
  // decrease the indentation
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
