// file: $isip/class/asr/SpeakerVerifier/sv_05.cc
// version: $Id: sv_05.cc,v 1.2 2003/11/07 16:18:28 tang Exp $
//

// isip include files
//
#include "SpeakerVerifier.h"

// method: run
//
// arguments:
//  const Sdb& sdb: (input) input signal data base
//
// return: a boolean value indicating status
//
// this method runs speaker verifier.
//
boolean SpeakerVerifier::run(Sdb& sdb_a) {

  // branch on the learning machine
  //
  if(algorithm_d == HMM) {

    hmm_d.setParamFile(param_file_name_d);
    hmm_d.setDebug(debug_level_d);
    hmm_d.setVerbosity(verbosity_d);
    hmm_d.setVerify(verify_d);
    
    // invoke the HMM run method
    //
    hmm_d.run(sdb_a);
  }

  // exit gracefully
  //
  return true;
}
