// file: $isip/class/algo/SegmentConcat/segc_01.cc
// version: $Id: segc_01.cc,v 1.2 2003/05/05 22:48:21 parihar Exp $
//

// isip include files
//
#include "SegmentConcat.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean SegmentConcat::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the algorithm choice
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
		  ALGO_MAP((long)algorithm_d));
  Console::put(output);

  // display the implementation name
  //
  output.debugStr(name(), msg_a, L"implementation_d",
                  IMPL_MAP.getName((long)implementation_d));
  Console::put(output);

  // display the dimension
  //
  String value;
  value.assign(dim_d);
  output.debugStr(name(), msg_a, L"dim_d", value);
  Console::put(output);
  
  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
