// file: $isip/class/asr/LanguageModel/lm_01.cc
// version: $Id: lm_01.cc,v 1.2 2002/02/01 17:13:46 huang Exp $
//

// isip include files
//
#include "LanguageModel.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
boolean LanguageModel::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String output;
 
  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // display the number of search levels
  //
  output.debugStr(name(), msg_a, L"num_level_d");
  Console::put(output);
  Long num(num_level_d);
  num.debug(L"number of levels");
  
  // display the vector of search levels
  //
  output.debugStr(name(), msg_a, L"search_levels_d");
  Console::put(output);
  search_levels_d.debug(L"vector of search levels");

  // display the graph starting symbol
  //
  output.debugStr(name(), msg_a, L"graph_start_d");
  Console::put(output);
  graph_start_d.debug(L"ISIP graph starting symbol");

  // display the graph starting symbol
  //
  output.debugStr(name(), msg_a, L"graph_term_d");
  Console::put(output);
  graph_term_d.debug(L"ISIP graph terminal symbol");
  
  // display the algorithm name
  //
  output.debugStr(name(), msg_a, L"algorithm_d",
                ALGO_MAP.getName(algorithm_d));
  Console::put(output);

  // decrease indention
  //
  Console::decreaseIndention();
 
  // exit gracefully
  //
  return true;
}
