// file: $isip/class/asr/LanguageModel/lm_04.cc
// version: $Id: lm_04.cc,v 1.2 2002/02/01 17:13:47 huang Exp $
//

// isip include files
//
#include "LanguageModel.h"

// method: sofSize
//
// arguments: none
//
// return: size of object
//
// this method returns the size of the object in the Sof file and is
// used for binary write
//
long LanguageModel::sofSize() const {
  
  // total things common to all algorithms
  //
  // start with the space required for the algorithm name
  //
  long bytes = ALGO_MAP.elementSofSize();

  // add the space required for the implementation name
  //
  bytes += IMPL_MAP.elementSofSize();

  // add the space required for the mode name
  //
  //bytes += DMODE_MAP.elementSofSize();

  // add the space required for the normalization name
  //
  bytes += NORM_MAP.elementSofSize();

  // add the space for the base class
  //
  //bytes += debug_level_d.sofSize();

  // total things common to specific algorithms
  //

  // check the algorithm:
  //  at this point, there are no algorithm or implementation specific
  //  data to be accounted for
  //

  // return the size
  //
  return bytes;
}

// method: write
//
// arguments:
//  Sof& sof: (input) sof file object
//  long tag: (input) sof object instance tag
//  const String& name: (input) sof object instance name
//
// return: a boolean value indicating status
//
// this method has the object write itself to an Sof file
//
boolean LanguageModel::write(Sof& sof_a, long tag_a,
			   const String& name_a) const {

  // declare local variables
  //
  long obj_size;

  // check the file type
  //
  if (sof_a.isText()) {
    obj_size = Sof::ANY_SIZE;
  }
  else {
    obj_size = sofSize();
  }
  
  // put the object into the sof file's index
  //
  if (!sof_a.put(name_a, tag_a, obj_size)) {
    return false;
  }

  // write data
  //
  
  // exit gracefully
  //
  return true;
}
