// file: $isip/class/search/HierarchicalSearch/hsrch_01.cc
// version: $Id: hsrch_01.cc,v 1.4 2002/08/15 16:37:53 huang Exp $
//

// isip include files
//
#include "HierarchicalSearch.h"

#ifndef ISIP_CONSOLE
#include <Console.h>
#endif

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: logical error status
//
// this is the debug method
//
boolean HierarchicalSearch::debug(const unichar* msg_a) const {
  
  // dump the data
  //
  String output;
  String value;

  // write the front end
  //
  //  value.assign(front_end_d);
  //  output.debugStr(name(), msg_a, L"front_end_d", value);  
  //  Console::put(output);

  // write the current frame
  //
  current_frame_d.debug(L"current_frame_d");
  
  // write the search levels
  //
  long num_levels = search_levels_d.length();
  String param;
  
  for (long i = 0; i < num_levels; i++) {
    param.assign(L"search_levels[");
    value.assign(i);
    param.concat(value);
    param.concat(L"]");
    output.assign(msg_a);
    output.concat(L": ");
    output.concat(param);
    search_levels_d(i).debug((unichar*)output);
  }
  
  // exit gracefully
  //
  return true;
}
