// file: $isip/class/stat/UniformModel/uni_01.cc
// version: $Id: uni_01.cc,v 1.2 2000/12/23 00:31:00 picone Exp $
//

// isip include files
//
#include "UniformModel.h"
#include <Console.h>

// method: debug
//
// arguments:
//  const unichar* msg: (input) message to print
//
// return: a boolean value indicating status
//
// this is the debug method
//
boolean UniformModel::debug(const unichar* msg_a) const {

  // declare local variables
  //
  String value;
  String output;

  // output an information message
  //
  output.debugStr(name(), msg_a, L":");
  Console::put(output);
  Console::increaseIndention();

  // output range information
  //
  Console::put(L"displaying min_d:");
  Console::increaseIndention();
  min_d.debug(L"min_d");
  Console::decreaseIndention();

  Console::put(L"displaying max_d:");
  Console::increaseIndention();
  max_d.debug(L"max_d");
  Console::decreaseIndention();

  // output the scale factor
  //
  value.assign(scale_d);
  output.debugStr(name(), msg_a, L"scale_d", value);
  Console::put(output);

  // output the computation mode information
  //
  output.debugStr(name(), msg_a, L"mode_d", MODE_MAP((ushort)mode_d));
  Console::put(output);
  
  value.assign(is_valid_d);
  output.debugStr(name(), msg_a, L"is_valid_d", value);
  Console::put(output);

  // decrease indention
  //
  Console::decreaseIndention();

  // exit gracefully
  //
  return true;
}
