#!/bin/sh
#

# file: $isip/login/mail_environment.sh
#
# this file defines some environment mail variables that are
# required for some mail tools. note that we no longer depend
# on standard Unix definitions - several tools are currently broken
# across platforms and automounted disks.
#

# define the location of the incoming mail folder - where
# unix delivers mail. note that some versions of bash/unix
# seem to have trouble with mailcheck, so we don't use it.
#
unset MAIL

ISIP_MAIL="/var/mail/$ISIP_USERNAME";
ISIP_MAILPATH="$ISIP_MAIL";
ISIP_MAILCHECK="10";

export ISIP_MAIL ISIP_MAILPATH ISIP_MAILCHECK;

# set the basic mail path
#
ISIP_MAILDIR="$HOME/mail/this_year/";
ISIP_MAILFOLDER="$ISIP_MAILDIR"rmail.mail;
export ISIP_MAILDIR ISIP_MAILFOLDER;

# set the location of a carbon copy folder and an alias file
#
ISIP_MAILCOPY=$ISIP_MAILDIR"smail.mail_new";
ISIP_MAILRC_0=$ISIP"/login/mail_mailrc.sh";
ISIP_MAILRC_1=$HOME"/login/mail_mailrc.sh";
export ISIP_MAILCOPY ISIP_MAILRC_0 ISIP_MAILRC_1;

# define some signatures
#
ISIP_MAIL_SIGNATURE_0="$HOME/login/mail_signature_0.text";
ISIP_MAIL_SIGNATURE_1="$HOME/login/mail_signature_1.text";
ISIP_MAIL_SIGNATURE_2="$HOME/login/mail_signature_2.text";
ISIP_MAIL_SIGNATURE_3="$HOME/login/mail_signature_3.text";
ISIP_MAIL_SIGNATURE_4="$HOME/login/mail_signature_4.text";
ISIP_MAIL_SIGNATURE_5="$HOME/login/mail_signature_5.text";

export ISIP_MAIL_SIGNATURE_0 ISIP_MAIL_SIGNATURE_1;
export ISIP_MAIL_SIGNATURE_2 ISIP_MAIL_SIGNATURE_3;
export ISIP_MAIL_SIGNATURE_4 ISIP_MAIL_SIGNATURE_5;

# define a default netnews folder
#
ISIP_GNUSFOLDER="netnews.mail";
export ISIP_GNUSFOLDER;

# end of file
# 
