#!/bin/sh
# 

# file: $isip/login/mail_procmailrc.sh
#
# this is the standard procmailrc file.
# a user should have a line like:
# INCLUDERC=.../mail_procmailrc.sh
# in their ~/.procmailrc file
#

# important definitions
#
DEFAULT_ISIP_ROOT="/isip/tools"
DEFAULT_ISIP="${DEFAULT_ISIP_ROOT}/ifc"

#------------------------------------------------------------------------------
# general isip stuff goes here:
#  this section usually sets the path, defines environment variables, etc.
#------------------------------------------------------------------------------

# define the location of the isip tools
#
:0
* ISIP ?? ^^^^
{ ISIP=$DEFAULT_ISIP }

:0
* ISIP_DEVEL ?? ^^^^
{ ISIP_DEVEL=$ISIP }

# the directory where the global scripts reside
#
ISIP_GLOBAL_SCRIPT_DIR=${ISIP_DEVEL}/login/mail_procmail_rules

# the main rules file
#
ISIP_RULE_FILE=${ISIP_GLOBAL_SCRIPT_DIR}/filter_config.rc

#------------------------------------------------------------------------------
# backups
#  create backups if requested
#------------------------------------------------------------------------------

:0 
* USE_BACKUPS ?? yes
{

  # verify that the backup folder exists
  #
  :0 
  * $!BACKUP_FOLDER ?? ^^^^
  {
    :0 c
    $BACKUP_FOLDER

    :0 ic
    | cd $BACKUP_FOLDER && rm -f dummy `ls -t msg.* | sed -e 1,1000d`
  }
}

#------------------------------------------------------------------------------
# backups
#  create backups if requested
#------------------------------------------------------------------------------
#
# If any of the filter flags are set then call the spam filter
#
:0 
* USE_ISIP_SPAM_FILTERS ?? no
* USE_SIMPLE_SPAM_FILTERS ?? no
* USE_STRICT_SPAM_FILTERS ?? no
{ }

:0 E
{
INCLUDERC=$ISIP_RULE_FILE
}
