#! @SH@

# file: $isip/util/misc/isip_netscape/isip_netscape.sh
#
# The isip_netscape utility is a wrapper that simply sets up a proper
# environment for netscape. This is more fallout from the change from
# xon, which properly invokes a user's shell on the remote machine,
# to xrsh, which doesn't. This script should really only be used
# in conjunction with xrsh.
#

# make sure there is an isip environment - must be done at the top
#
if (test -z "$ISIP") then
    . $HOME/.bashrc;
fi

# important definitions
#
PROGRAM_NAME="isip_netscape";

ISIP_HELP_FILE="$ISIP/util/misc/isip_netscape/isip_netscape.help";
export ISIP_HELP_FILE;

# execute a generic help function:
#  force the shellscript to exit if a help option is encountered.
set -e;
isip_function_help_0 $*;
set +e;

# clear the classpath so the plugin won't get confused
#
unset CLASSPATH;

# invoke netscape
#
exec netscape $* &

#
# end of file
