#! @SH@
#
# file: $isip/util/misc/isip_startxgo.sh
#
# this file is a minimally modified version of graphon's startxgo.
# only one line has been changed - the default location of xinitrc
# (search for isip_modification)
#
# 07/15/95 (joe picone):	first version
#

# important help-related definitions
#
PROGRAM_NAME="$0";
 
ISIP_HELP_FILE="$ISIP/util/misc/isip_startxgo/isip_startxgo.help";
export ISIP_HELP_FILE;
 
# execute a generic help function:
#  force the shellscript to exit if a help option is encountered.
set -e;
isip_function_help_0 $*;
set +e;

#------------------------------------------------------------------------------
# graphons original startxgo starts here
#------------------------------------------------------------------------------
#
# -- startxgo -- adapted from:
#
#
# $XConsortium: startx.cpp,v 1.4 91/08/22 11:41:29 rws Exp $
# 
# This is just a sample implementation of a slightly less primitive 
# interface than xinit.  It looks for user .xinitrc and .xserverrc
# files, then system xinitrc and xserverrc files, else lets xinit choose
# its default.  The system xinitrc should probably do things like check
# for .Xresources files and merge them in, startup up a window manager,
# and pop a clock and serveral xterms.
#
# Site administrators are STRONGLY urged to write nicer versions.
# 

if [ "`tty`" = "/dev/console" ]; then
    echo "This script must be executed from a serial X Terminal."
    echo -n "Is /dev/console a serial X Terminal? [n] "
    read answer
    if [ "$answer" != "y" -a "$answer" != "Y" ]; then
        exit
    fi
fi

if [ "$XGOHOME" = "" ]; then
    if [ -d /opt/XGOr5 ]; then
        XGOHOME=/opt/XGOr5
    fi
    echo "\$XGOHOME environment variable not defined.  Please define this"
    echo "variable to point to the directory where the serial X server"
    echo "resides and run this script again."
    exit
fi

# Set up directories for use later.

# isip modification is below
userclientrc="$HOME/login/x11_xinitrc.sh"
# continue with standard graphon file
userserverrc=$HOME/.xserverrc
sysclientrc=$XGOHOME/lib/X11/xinit/xinitrc
sysserverrc=$XGOHOME/lib/X11/xinit/xserverrc
bin=$XGOHOME/bin 
lib=$XGOHOME/lib
fontpath=$XGOHOME/lib/X11/fonts

# -pl 3 turns on compressed packet mode
# -tt says what tty device to use
clientargs=""
serverargs="-bm 800x600 -pl 0 -tt `tty` -fp $fontpath/misc,$fontpath/Speedo,$fontpath/75dpi,$fontpath/100dpi -co $XGOHOME/lib/X11/rgb"
xinit=xgoinit

if [ -f $userclientrc ]; then
    clientargs=$userclientrc
else 
    if [ -f $sysclientrc ]; then
        clientargs=$sysclientrc
    fi
fi

if [ -f $userserverrc ]; then
    serverargs=$userserverrc
else 
    if [ -f $sysserverrc ]; then
        serverargs=$sysserverrc
    fi
fi

whoseargs="client"
while [ "x$1" != "x" ]; do
    case "$1" in
	/''*|\.*)	if [ "$whoseargs" = "client" ]; then
		    clientargs="$1"
		else
		    serverargs="$1"
		fi ;;
	--)	whoseargs="server" ;;
	*)	if [ "$whoseargs" = "client" ]; then
		    clientargs="$clientargs $1"
		else
		    serverargs="$serverargs $1"
		fi ;;
    esac
    shift
done

# add our X lib to the ldlib path
LD_LIBRARY_PATH=$lib:$LD_LIBRARY_PATH; export LD_LIBRARY_PATH;

PATH=$bin:$PATH; export PATH; ## echo path is "$PATH"

# This line in un-Xgo-like:
#  echo $xinit $clientargs -- $serverargs

$xinit $clientargs -- Xgo $serverargs

#
# end of file
