#! @SH@
#------------------------------------------------------------------------------
#
# File: $signal/util/file/rcs/ci.sh
#
# The CI function checks in RCS files.  
# Protection on the file is set to read-only.
# An external form for help is used.
#
#------------------------------------------------------------------------------
# Define Help Message
#------------------------------------------------------------------------------
#display_help_message () {
#  sf $signal/util/file/rcs/ci.help
#  exit 0;
#}
#------------------------------------------------------------------------------
# Check For An Argument Requesting Help -- Display Help Message And Exit
#------------------------------------------------------------------------------
#if (test $# -eq 0) then
#   display_help_message;
#else 
#    for arg do
#        if (test "$arg" = "-help") then
#            display_help_message;
#        fi
#    done
#fi

#------------------------------------------------------------------------------
# make sure that this directory is not managed by CVS
#------------------------------------------------------------------------------
for arg do
   dir=`dirname $arg`;
   cvs_check=`ls $dir | grep CVS`;
   if (test "x$cvs_check" != "x") then

      # give the user an error message
      #
      echo "Files in this directory are managed by CVS, not RCS. Please read"
      echo "organizational policy on the proper use of revision control software."
      # report this infraction to help@isip
      #
      mail help@isip.msstate.edu <<EOF
Subject: CVS/RCS INFRACTION


User $USER tried to rcs the following file(s), one or more of which is
maintained by CVS:

  files = $*
  current directory = `pwd`

Please take appropriate action to preserve repository integrity.

-RCS/CVS watchdog
EOF

      exit 1
   fi
done

#------------------------------------------------------------------------------
# Check In File(s) With No-Lock Option Set
#------------------------------------------------------------------------------
ci -u $*
#------------------------------------------------------------------------------
# Unlock All Checked-In Files 
#  Note: To Catch Files That Didn't Change And Were Aborted During Check-In
#------------------------------------------------------------------------------
rcs -u $* 2> /dev/null
#------------------------------------------------------------------------------
# Change Mode To Read-Only For All Files (Skip Any Options)
#------------------------------------------------------------------------------
for arg do
    if (test -f $arg) then
        chmod a-w $arg
    fi
done
#------------------------------------------------------------------------------
# End
#------------------------------------------------------------------------------
exit 0
