// file: Vertex.java
//

// import java libraries
//
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.lang.*;
import javax.swing.border.*;

public class Vertex extends JButton implements Serializable, Constants {

    // ---------------------------------------------------
    //
    // declare class member data
    //
    // ---------------------------------------------------

    // the relevant information about the vertex
    //
    public String vertexName = null;
    public String iconName = null;
    public int vertexType = NONE;
    public int vertexImpl = NONE;
    public ImageIcon vertexIcon = null;
    public Point vertexLocation = null;
    
    // the parents and children of the vertex
    //
    public Vector vertexParents = null;
    public Vector vertexChildren = null;

    // the dimensions of the vertex
    //
    public int vertexWidth = -1;
    public int vertexHeight = -1;

    // container related data types
    //
    public Vector vertexContainer = null;

    // parameters used by the algorithm vertex
    //
    public Vector values =new Vector(5,5);
    public Vector names = new Vector(5,5);
    public Vector types = new Vector(5,5);
    public String association = null;
    public Vector subclass =new Vector(5,5); 
    public int max_subclass = 0;
    public Vector subparam =new Vector(5,5); 
    public int max_subparam = 0;
    public Vector identify = new Vector(5,5);

    public boolean actionAdded = false;
    public static boolean isAdd = false;

    // ---------------------------------------------------
    //
    // class constructors
    //
    // ---------------------------------------------------

    // method: Vertex
    //
    // arguments: none
    // returns: none
    //
    public Vertex() {
	
	// invoke the parent constructor
	//
	super();

	// set the font of the vertex
	//
	setFont(newFont);

	// disable the focus from being painted
	//
	setFocusPainted(false);

	// disable the content area from being painted
	//
	setContentAreaFilled(false); 

	// set the horizontal text position
	//
	setHorizontalTextPosition(SwingConstants.CENTER);

	// initialize class vector data types
	//
	vertexParents = new Vector(10, 10);
	vertexChildren = new Vector(10, 10);

	// set the default dimensions of the vertex
	//
	setBackground(Color.white);
	setSize(VERTEX_WIDTH, VERTEX_HEIGHT);
	setPreferredSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	setMinimumSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	setVertexWidth(VERTEX_WIDTH);
	setVertexHeight(VERTEX_HEIGHT);
    }

    // method: Vertex
    //
    // arguments:
    //   String name: (input) vertex name
    //   int type: (input) vertex type
    // returns: none
    //
    public Vertex(String name) {
	
	// invoke the parent constructor
	//
	super(name);	
	//setBorder(LineBorder.createGrayLineBorder());
	//setBorder(new EtchedBorder());
	//setBorderPainted(true);
	// set the font of the vertex
	//
	setFont(newFont);

	// disable the focus from being painted
	//
	//setFocusPainted(true);

	// disable the content area from being painted
	//
	//setContentAreaFilled(true); 

	// set the horizontal text position
	//
	//setHorizontalTextPosition(SwingConstants.CENTER);	
    }

    // method: Vertex
    //
    // arguments:
    //   String name: (input) vertex name
    //   int type: (input) vertex type
    // returns: none
    //
    public Vertex(String name, int type, int impl) {
	
	// invoke the parent constructor
	//
	super(name);

	// set the format and name of the vertex
	//
	vertexName = name;
	vertexType = type;
	vertexImpl = impl;

	// set the name of the vertex
	//
	if (name.length() > 3) {
	    setText(name.substring(0, 3));
	}
	else {
	    setText(name);
	}

	// set the font of the vertex
	//
	setFont(newFont);

	// disable the focus from being painted
	//
	setFocusPainted(false);

	// disable the content area from being painted
	//
	setContentAreaFilled(false); 

	// set the horizontal text position
	//
	setHorizontalTextPosition(SwingConstants.CENTER);

	// initialize class vector data types
	//
	switch (vertexType) {

	case CONTAINER:
	    vertexParents = new Vector(10, 10);
	    vertexChildren = new Vector(10, 10);
	    vertexContainer = new Vector(50, 10);
	    break;	    
	default:
	    vertexParents = new Vector(10, 10);
	    vertexChildren = new Vector(10, 10);
	    break;
	}

	// set the default dimensions of the vertex
	//
	switch (vertexType) {

	case ALGORITHM:
	    setBackground(Color.white);
	    setSize(ALGORITHM_WIDTH, ALGORITHM_HEIGHT);
	    setPreferredSize(new Dimension(ALGORITHM_WIDTH, ALGORITHM_HEIGHT));
	    setMinimumSize(new Dimension(ALGORITHM_WIDTH, ALGORITHM_HEIGHT));
	    setVertexWidth(ALGORITHM_WIDTH);
	    setVertexHeight(ALGORITHM_HEIGHT);
	    break;
	case CONTAINER:
	    setBackground(Color.white);
	    setSize(CONT_WIDTH, CONT_HEIGHT);
	    setPreferredSize(new Dimension(CONT_WIDTH, CONT_HEIGHT));
	    setMinimumSize(new Dimension(CONT_WIDTH, CONT_HEIGHT));
	    setVertexWidth(CONT_WIDTH);
	    setVertexHeight(CONT_HEIGHT);
	    break;	    
	default:
	    setBackground(Color.cyan);
	    setSize(VERTEX_WIDTH, VERTEX_HEIGHT);
	    setPreferredSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	    setMinimumSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	    setVertexWidth(VERTEX_WIDTH);
	    setVertexHeight(VERTEX_HEIGHT);
	    break;
	}
    }

    // method: Vertex
    //
    // arguments:
    //   int type: (input) vertex type
    //   ImageIcon icon: (input) vertex icon
    // returns: none
    //
    public Vertex(ImageIcon icon, int type) {

	// invoke the parent constructor
	//
	super(icon);

	// set the format for the vertex
	//
	vertexName = new String("Algorithm");
	vertexIcon = icon;
	vertexType = type;
	vertexImpl = NONE;

	// set the font of the vertex
	//
	setFont(newFont);

	// disable the focus from being painted
	//
	setFocusPainted(false);

	// disable the content area from being painted
	//
	setContentAreaFilled(false); 

	// set the horizontal text position
	//
	setHorizontalTextPosition(SwingConstants.CENTER);

	// initialize class vector data types
	//
	switch (vertexType) {

	case CONTAINER:
	    vertexParents = new Vector(10, 10);
	    vertexChildren = new Vector(10, 10);
	    vertexContainer = new Vector(50, 10);
	    break;	    
	default:
	    vertexParents = new Vector(10, 10);
	    vertexChildren = new Vector(10, 10);
	    break;
	}

	// set the default dimensions of the vertex
	//
	switch (vertexType) {

	case ALGORITHM:
	    setBackground(Color.white);
	    setSize(ALGORITHM_WIDTH, ALGORITHM_HEIGHT);
	    setPreferredSize(new Dimension(ALGORITHM_WIDTH, ALGORITHM_HEIGHT));
	    setMinimumSize(new Dimension(ALGORITHM_WIDTH, ALGORITHM_HEIGHT));
	    setVertexWidth(ALGORITHM_WIDTH);
	    setVertexHeight(ALGORITHM_HEIGHT);
	    break;
	case CONTAINER:
	    setBackground(Color.white);
	    setSize(CONT_WIDTH, CONT_HEIGHT);
	    setPreferredSize(new Dimension(CONT_WIDTH, CONT_HEIGHT));
	    setMinimumSize(new Dimension(CONT_WIDTH, CONT_HEIGHT));
	    setVertexWidth(CONT_WIDTH);
	    setVertexHeight(CONT_HEIGHT);
	    break;	    
	default:
	    setBackground(Color.cyan);
	    setSize(VERTEX_WIDTH, VERTEX_HEIGHT);
	    setPreferredSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	    setMinimumSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	    setVertexWidth(VERTEX_WIDTH);
	    setVertexHeight(VERTEX_HEIGHT);
	    break;
	}
    }

    // method: Vertex
    //
    // arguments:
    //   ImageIcon icon: (input) vertex icon
    //   String name: (input) vertex name
    //   int type: (input) vertex type
    //   int impl: (input) vertex implementation
    // returns: none
    //
    public Vertex(ImageIcon icon, String name, int type, int impl) {

	// invoke the parent constructor
	//
	super(icon);

	// set the format for the vertex
	//
	vertexName = name;
	vertexIcon = icon;
	vertexType = type;
	vertexImpl = impl;

	// set the vertex text
	//
	if (name.length() > 3) {
	    setText(name.substring(0, 3));
	}
	else {
	    setText(name);
	}
	
	if(type == GENERATOR_DATA) {
	    setText("");
	} 
	
	// set the font of the vertex
	//
	setFont(newFont);

	// disable the focus from being painted
	//
	setFocusPainted(false);

	// disable the content area from being painted
	//
	setContentAreaFilled(false); 

	// set the horizontal text position
	//
	setHorizontalTextPosition(SwingConstants.CENTER);

	// initialize class vector data types
	//
	switch (vertexType) {

	case CONTAINER:
	    vertexParents = new Vector(10, 10);
	    vertexChildren = new Vector(10, 10);
	    vertexContainer = new Vector(50, 10);
	    break;	    
	default:
	    vertexParents = new Vector(10, 10);
	    vertexChildren = new Vector(10, 10);
	    break;
	}

	// set the default dimensions of the vertex
	//
	switch (vertexType) {

	case ALGORITHM:
	    setBackground(Color.white);
	    setSize(ALGORITHM_WIDTH, ALGORITHM_HEIGHT);
	    setPreferredSize(new Dimension(ALGORITHM_WIDTH, ALGORITHM_HEIGHT));
	    setMinimumSize(new Dimension(ALGORITHM_WIDTH, ALGORITHM_HEIGHT));
	    setVertexWidth(ALGORITHM_WIDTH);
	    setVertexHeight(ALGORITHM_HEIGHT);
	    break;
	case CONTAINER:
	    setBackground(Color.white);
	    setSize(CONT_WIDTH, CONT_HEIGHT);
	    setPreferredSize(new Dimension(CONT_WIDTH, CONT_HEIGHT));
	    setMinimumSize(new Dimension(CONT_WIDTH, CONT_HEIGHT));
	    setVertexWidth(CONT_WIDTH);
	    setVertexHeight(CONT_HEIGHT);
	    break;	    
	default:
	    setBackground(Color.white);
	    setSize(VERTEX_WIDTH, VERTEX_HEIGHT);
	    setPreferredSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	    setMinimumSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	    setVertexWidth(VERTEX_WIDTH);
	    setVertexHeight(VERTEX_HEIGHT);
	    break;
	}
    }

    // method: Vertex
    //
    // arguments: none
    // returns: none
    //
    public Vertex(Vertex copy) {
		
	super();

	// set the vertex parameters
	//
	vertexType = copy.vertexType;
	vertexImpl = copy.vertexImpl;
	if (copy.vertexName != null) {
	    vertexName = new String(copy.vertexName);	    
	    if (vertexName.length() > 4) {
		setText(vertexName.substring(0, 4));
	    }
	    else {
		setText(vertexName);
	    }
	    if(vertexName.equals("Generator")) {
		setText("");      
	    }

	    if(vertexName.equals("FilterBank")) {
		setText("FilB");      
	    }
	    setVertexName(vertexName);

	    if(copy.iconName != null) {
		 iconName = new String(copy.iconName);
		 setText(iconName);
	    }
	}
	if ((copy.vertexIcon != null)&&(copy.vertexIcon.getImage() != null)) {
	    vertexIcon = new ImageIcon(copy.vertexIcon.getImage());
	    setIcon(vertexIcon);
	}

	// set the vertex arcs parameters
	//
	if (copy.vertexLocation != null) {
	    vertexLocation = new Point(copy.vertexLocation);
	}

	// set the vertex parents, children and container elements
	//
	if (copy.vertexParents != null) {
	    vertexParents = new Vector(copy.vertexParents);
	}
	if (copy.vertexChildren != null) {
	    vertexChildren = new Vector(copy.vertexChildren);
	}
	if (copy.vertexContainer != null) {
	    vertexContainer = new Vector(copy.vertexContainer);
	}

	// set the vertex vertex dimensions
	//
	vertexWidth = copy.vertexWidth;
	vertexHeight = copy.vertexHeight;

	// set the algorithm related parameters
	//
	if (copy.values != null) {
	    values = new Vector(copy.values);
	}
	if (copy.names != null) {
	    names = new Vector(copy.names);
	}
	if (copy.types != null) {
	    types = new Vector(copy.types);
	}
	if ( copy.association != null) {
	    association = new String(copy.association);
	}
	if (copy.subclass != null) {
	    subclass = new Vector(copy.subclass);
	}
	max_subclass = copy.max_subclass;
	if (copy.subparam != null) {
	    subparam = new Vector(copy.subparam);
	}
	max_subparam = copy.max_subparam;
	actionAdded = copy.actionAdded;

	// set the font of the vertex
	//
	setFont(newFont);

	// disable the focus from being painted
	//
	setFocusPainted(false);

	// disable the content area from being painted
	//
	setContentAreaFilled(false); 

	// set the horizontal text position
	//
	setHorizontalTextPosition(SwingConstants.CENTER);

	// set the default dimensions of the vertex
	//
	switch (vertexType) {

	case ALGORITHM:
	    setBackground(Color.white);
	    setContentAreaFilled(false); 
	    setHorizontalTextPosition(SwingConstants.CENTER);
	    setSize(ALGORITHM_WIDTH, ALGORITHM_HEIGHT);
	    setPreferredSize(new Dimension(ALGORITHM_WIDTH, ALGORITHM_HEIGHT));
	    setMinimumSize(new Dimension(ALGORITHM_WIDTH, ALGORITHM_HEIGHT));
	    setVertexWidth(ALGORITHM_WIDTH);
	    setVertexHeight(ALGORITHM_HEIGHT);
	    break;
	case CONTAINER:
	    setBackground(Color.white);
	    setContentAreaFilled(false);
	    setHorizontalTextPosition(SwingConstants.CENTER);
	    setSize(CONT_WIDTH, CONT_HEIGHT);
	    setPreferredSize(new Dimension(CONT_WIDTH, CONT_HEIGHT));
	    setMinimumSize(new Dimension(CONT_WIDTH, CONT_HEIGHT));
	    setVertexWidth(CONT_WIDTH);
	    setVertexHeight(CONT_HEIGHT);
	    break;	    
	default:
	    setBackground(Color.cyan);
	    setContentAreaFilled(false);
	    setHorizontalTextPosition(SwingConstants.CENTER);
	    setSize(VERTEX_WIDTH, VERTEX_HEIGHT);
	    setPreferredSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	    setMinimumSize(new Dimension(VERTEX_WIDTH, VERTEX_HEIGHT));
	    setVertexWidth(VERTEX_WIDTH);
	    setVertexHeight(VERTEX_HEIGHT);
	    break;
	}
    }

    // ---------------------------------------------------
    //
    // declare class public methods
    //
    // ---------------------------------------------------

    // method: clear
    //
    // arguments: none
    // returns: none
    //
    // clears all lists associated this the vertex
    //
    public void clear() {
	if (vertexParents != null) {
	    vertexParents.removeAllElements();
	}
	if (vertexChildren != null) {
	    vertexChildren.removeAllElements();
	}
	if (vertexContainer != null) {
	    vertexContainer.removeAllElements();
	}
    }

    // method: changeConnectors
    //
    // arguments:
    //   int destination: destination connector
    //   Vertex src:  the parent vertex that will be set to the destination
    // returns  : none
    //
    // method changes the order of the connectors for the connector vertex
    //
    public void changeConnectors(int dest, Vertex src) {

	// declare local variables
	//
	int stop = 0;
	Vertex vertex = src;

	// reduce to the source and destination to zero based values
	//
	stop = dest - 1;	

	// determine if the source is valid
	//
	if (stop >= vertexParents.size()) {
	    return;
	}
	
	// remove the element at the start location
	//
	vertexParents.set(stop, vertex);
    }

    // method: getVertexName
    //
    // arguments: none
    // returns: class name
    //
    // gets the class name
    //
    public String getVertexName() {
	return vertexName;
    }

    // method: setVertexName
    //
    // arguments:
    //   String name: class name
    // returns: method status
    //
    // sets the class name
    // 
    public boolean setVertexName(String name) {
	vertexName = name;
	return true;
    }

    // method: getIconName
    //
    // arguments: none
    // returns: class icon name
    //
    // gets the class icon name
    //
    public String getIconName() {
	return iconName;
    }

    // method: setIconName
    //
    // arguments:
    //   String name: class icon name
    // returns: method status
    //
    // sets the class icon name
    // 
    public boolean setIconName(String name) {
	iconName = name;
	return true;
    }

    // method: getVertexIcon
    //
    // arguments: none
    // returns: class icon
    //
    // gets the class icon
    //
    public ImageIcon getVertexIcon() {
	return vertexIcon;
    }

    // method: setVertexIcon
    //
    // arguments:
    //   ImageIcon icon: class icon
    // returns: method status
    //
    // sets the class icon
    // 
    public boolean setVertexIcon(ImageIcon icon) {
	vertexIcon = icon;
	return true;
    }

    // method: getInDegree
    //
    // arguments: none
    // returns: number of incoming arcs
    //
    // get the number of arcs coming into the vertex
    // 
    public int getInDegree() {
	return vertexParents.size();
    }

    // method: getOutDegree
    //
    // arguments: none
    // returns: number of outgoing arcs
    //
    // get the number of arcs leaving th vertex
    // 
    public int getOutDegree() {
	return vertexChildren.size();
    }

    // method: getVertexType
    //
    // arguments: none
    // returns: vertex type
    //
    // gets the vertex type
    // 
    public int getVertexType() {
	return vertexType;
    }

    // method: setType
    //
    // arguments:
    //   int type: (input) vertex type
    // returns: method status
    //
    // sets the vertex type
    // 
    public boolean setType(int type) {
	vertexType = type;
	return true;
    }

    // method: setType
    //
    // arguments:
    //   String type: (input) vertex type
    // returns: method status
    //
    // sets the vertex type
    // 
    public boolean setType(String type) {        
	return true;
    }

    // method: getType
    //
    // arguments: none
    // returns: method status
    //
    // gets the vertex type
    // 
    public String getType() {

	// return the vertex type
	//
	if (vertexType == SAMPLED_DATA) {
	    return SAMPLED_DATA_STR;
	}
	else if (vertexType == FEATURE_DATA) {
	    return FEATURE_DATA_STR;
	}
	else if (vertexType == GENERATOR_DATA) {
	    return GENERATOR_DATA_STR;
	}
	else if (vertexType == ALGORITHM) {
	    return ALGORITHM_STR;
	}
	else if (vertexType == CONTAINER) {
	    return CONTAINER_STR;
	}
	else if (vertexType == INPUT) {
	    return INPUT_STR;
	}
	else if (vertexType == OUTPUT) {
	    return OUTPUT_STR;
	}
	else if (vertexType == CUSTOM) {
	    return CUSTOM_STR;
	}
	else {
	    return NONE_STR;
	}
    }

    // method: getVertexImpl
    //
    // arguments: none
    // returns: class implementation
    //
    // gets the class implementation
    //
    public int getVertexImpl() {
	return vertexImpl;
    }

    // method: setVertexImpl
    //
    // arguments:
    //   String impl: class implementation
    // returns: method status
    //
    // sets the class implementation
    // 
    public boolean setVertexImpl(int impl) {
	vertexImpl = impl;
	return true;
    }

    // method: containsChild
    //
    // arguments:
    //   Vertex child: (input) child we intend to find
    // returns: method status
    //
    // checks if the input is a child
    // 
    public boolean containsChild(Vertex child) {
	return vertexChildren.contains(child);
    }

    // method: containsParent
    //
    // arguments:
    //   Vertex parent: (input) parent we intend to find
    // returns: method status
    //
    // checks if the input is a parent
    // 
    public boolean containsParent(Vertex parent) {
	return vertexParents.contains(parent);
    }

    // method: insertContainerElement
    //
    // arguments:
    //   Vertex vertex: (input) vetrex to be inserted
    // returns: none
    //
    // inserts a vertex into the container
    // 
    public void insertContainerElement(Vertex vertex) {
	
	// add the vertex to the required data structures
	//
	vertexContainer.addElement(vertex);
    }

    // method: getVertexLocation
    //
    // arguments: none
    // returns: method status
    //
    // gets the location of the vertex
    // 
    public Point getVertexLocation() {

	// declare local variables
	//
	Point point = null;

	// get the position of the bean
	//
	point = this.getLocation(point);

	// retrieve the location of the bean
	//
	double xloc = point.getX();
	double yloc = point.getY();

	// return the location of the bean
	//
	return (new Point((int)xloc, (int)yloc));
    }

    // method: updateLocation
    //
    // arguments: 
    //    int xloc: x-coordinate of the bean
    //    int yloc: y-coordinate of the bean
    //
    // returns  : none
    //
    // method returns the name of the bean
    //
    public void updateLocation(int xloc, int yloc) {

	// check to make sure that the memory has been allocated
	//
	if (vertexLocation == null) {
	    vertexLocation = new Point();
	}

	// update the location of the bean
	//
	vertexLocation.x = xloc;
	vertexLocation.y = yloc;
    }

    // method: getVertexWidth
    //
    // arguments: none
    // returns: method status
    //
    // gets the width of the vertex
    // 
    public int getVertexWidth() {
	return vertexWidth;
    }

    // method: getVertexHeight
    //
    // arguments: none
    // returns: method status
    //
    // gets the height of the vertex
    // 
    public int getVertexHeight() {
	return vertexHeight;
    }

    // method: setVertexHeight
    //
    // arguments:
    //   int height: (input) new height of the vertex
    // returns: method status
    //
    // sets the height of the vertex
    // 
    public boolean setVertexHeight(int height) {
	vertexHeight = height;
	return true;
    }

    // method: setVertexWidth
    //
    // arguments:
    //   int width: (input) new width of the vertex
    // returns: method status
    //
    // sets the width of the vertex
    // 
    public boolean setVertexWidth(int width) {
	vertexWidth = width;
	return true;
    }

    // method: getParents
    //
    // arguments: none
    // returns: list of parents
    //
    // gets the list of parents associated with the vertex
    //
    public Vector getParents() {
	return vertexParents;
    }

    // method: addParent
    //
    // arguments:
    //   Vertex parent: (input) new parent to be added
    // returns: method status
    //
    // adds the parent to the list
    // 
    public boolean addParent(Vertex parent) {	
	if (!vertexParents.contains(parent)) {
	    vertexParents.addElement(parent);
	    return true;
	}
	return false;
    }

    // method: addParent
    //
    // arguments:
    //   Vertex parent: (input) new parent to be added
    //   int index: (input) index at which the parent is to be added
    // returns: method status
    //
    // adds the parent to the list
    // 
    public boolean addParent(Vertex parent, int index) {	
	if (!vertexParents.contains(parent)) {
	    if (index >= vertexParents.size()) {
		vertexParents.setSize(index + 1);
	    }
	    vertexParents.setElementAt(parent, index);
	    return true;
	}
	return false;
    }

    // method: removeParent
    //
    // arguments:
    //   Vertex parent: (input) parent to be removed
    // returns: method status
    //
    // removes the parent from the list
    // 
    public boolean removeParent(Vertex parent) {
	return vertexParents.removeElement(parent);
    }

    // method: getChildren
    //
    // arguments: none
    // returns: list of children
    //
    // gets the list of children associated with the vertex
    //
    public Vector getChildren() {
	return vertexChildren;
    }

    // method: addChild
    //
    // arguments:
    //   Vertex child: (input) new child to be added
    // returns: none
    //
    // adds the child to the list
    // 
    public boolean addChild(Vertex child) {
	if (!vertexChildren.contains(child)) {
	    vertexChildren.addElement(child);
	    return true;
	}
	return false;
    }

    // method: addChild
    //
    // arguments:
    //   Vertex child: (input) new child to be added
    //   int index: (input) index at which the child is to be added
    // returns: none
    //
    // adds the child to the list
    // 
    public boolean addChild(Vertex child, int index) {
	if (!vertexChildren.contains(child)) {
	    if (index >= vertexChildren.size()) {
		vertexChildren.setSize(index + 1);
	    }
	    vertexChildren.setElementAt(child, index);
	    return true;
	}
	return false;
    }

    // method: removeChild
    //
    // arguments:
    //   Vertex child: (input) child to be removed
    // returns: method status
    //
    // removes the child from the list
    // 
    public boolean removeChild(Vertex child) {
	return vertexChildren.removeElement(child);
    }

    // method: updateVertexDimensions
    //
    // arguments: none
    // returns  : none
    //
    // method resets and revalidates the vertex dimension
    //
    public void updateVertexDimensions() {
	
	// declare local variables
	//
	int newWidth = 0;
	int newHeight = 0;

	// check if the parent vector has been initialized
	//
	if (vertexParents == null) {
	    return;
	}

	// determine the width of the vertex
	//
	if (vertexParents.size() == 0) {
	    newWidth =  this.vertexWidth;
	} else {
	    newWidth =  (vertexParents.size() * this.vertexWidth);
	}

	// determine the height of the vertex
	//
	newHeight = this.getVertexHeight();

	// set the new vertex dimensions
	//
	this.setSize(new Dimension(newWidth, newHeight));
	this.setMinimumSize(new Dimension(newWidth, newHeight));
	this.setPreferredSize(new Dimension(newWidth, newHeight));
    }

    // method: initializeConfig
    //
    // arguments:
    //   Vector n: (input) vector of algorithm names
    //   Vector v: (input) vector of algorithm values
    //   Vector t: (input) vector of algorithm data types
    //   String s: (input) algorithm immage association
    //   Data d: (input) algorithm data object
    // returns  : none
    //
    // initializes the configuration parameters of the algorithm vertex
    //
    public void initializeConfig(Vector n, Vector v, Vector t, 
				 String a, Data d) {
	
	// initialize data members
	//
	names = n;
	types = t;
	association = a;
	Data data = d;

	values = new Vector(5,5);
	subclass = new Vector(2,1);

	for(int i=0; i < v.size(); i++) {

	    // if enumerated type, get the first value
	    //	
	    if(types.get(i).equals(ALGORITHM_ENUM)){
		Vector enum_values = (Vector)v.get(i);
		values.add(enum_values.get(0));
	    }

	    // add a default subclass with basic parameters here to begin with
	    // this still needs to be worked out properly
	    //
	    else if (types.get(i).equals(ALGORITHM_CLASS)) {
		values.add(v.get(i));
		max_subclass++;
		
		String image_name = null;
		String image_association= null;
		
		// tells the program which ALGORITHM it is looking to match
		//
		image_association = (String)values.get(i);

		// scans through the association until it finds the 
		// smallIcon key
		//
		for(int j=data.association.indexOf(image_association); 
		    j <= data.association.lastIndexOf(image_association);
		    j++) {
		    if(j != -1) {
			if(((String)(data.name.get(j))).equals(ALGORITHM_ICON_SMALL)) {
			    // sets the image_name to the value held in 
			    // small icon
			    //
			    image_name = (String)data.values.get(j);
			}
		    }
		}
		    
		// check to see if the file exists. If it does not exist,
		// use a default image
		//
		if(image_name != null){
		    File image_file = new File(image_name);
		    if (image_file.exists() == false)
			image_name = ALGORITHM_DEFAULT;
		}
		else {
		    image_name = ALGORITHM_DEFAULT;
		}

		if(image_association.equals("FourierTransform"))
		    image_name = GUI_PATH +"/lib/images/isip_transform_builder/icons/fourier_01.gif";

		// create the icons for the config panel
		//
		ImageIcon icon = new ImageIcon(image_name);
		
		// create the button for the config panel
		//
		Vertex button = new Vertex(icon, ALGORITHM);
		
		// to simplify the creation, the data vectors will be trimmed 
		// to only include the ALGORITHM we're looking at and saved 
		// into these three vectors for use in a bit
		//
		Vector labels2 = new Vector(5,5);
		Vector types2 = new Vector(5,5);
		Vector values2 = new Vector(5,5);
		
		for(int j=data.association.indexOf(image_association); 
		    j <= data.association.lastIndexOf(image_association);
		    j++) {
		    if(j != -1) {
			labels2.add(data.name.get(j));
			types2.add(data.type.get(j));
			values2.add(data.values.get(j));
		    }
		}	 

		// initialize the vertex to the default values for its type
		//
		button.initializeConfig(labels2, values2, types2,
					image_association, data);
		
		// add subclass button to the vector
		//
		subclass.add(button);
	
		// attach an action listener to the button
		//
		button.setActionCommand(ALGORITHM_CLASS);
	    }

	    // add sub parameters here to begin with
	    // this still needs to be worked out properly
	    //
	    else if (types.get(i).equals(ALGORITHM_PARAM)) {
		values.add(v.get(i));
		max_subparam++;
		
		String image_name = null;
		String image_association= null;
		
		// tells the program which ALGORITHM it is looking to match
		//
		image_association = (String)values.get(i);

		// scans through the association until it finds the 
		// smallIcon key
		//
		for(int j=data.association.indexOf(image_association); 
		    j <= data.association.lastIndexOf(image_association);
		    j++) {
		    if(j != -1) {
			if(((String)(data.name.get(j))).equals(ALGORITHM_ICON_SMALL)) {
			    // sets the image_name to the value held in 
			    // small icon
			    //
			    image_name = (String)data.values.get(j);
			}
		    }
		}
		    
		// check to see if the file exists. If it does not exist,
		// use a default image
		//
		if(image_name != null){
		    File image_file = new File(image_name);
		    if (image_file.exists() == false)
			image_name = ALGORITHM_DEFAULT;
		}
		else {
		    image_name = ALGORITHM_DEFAULT;
		}
		
		if(image_association.equals("FourierTransform"))
		    image_name = GUI_PATH +"/lib/images/isip_transform_builder/icons/fourier_01.gif";

		// create the icons for the config panel
		//
		ImageIcon icon = new ImageIcon(image_name);
		
		// create the button for the config panel
		//
		Vertex button = new Vertex(icon, ALGORITHM);
		button.association = image_association;

		// to simplify the creation, the data vectors will be trimmed 
		// to only include the ALGORITHM we're looking at and saved 
		// into these three vectors for use in a bit
		//
		Vector labels2 = new Vector(5,5);
		Vector types2 = new Vector(5,5);
		Vector values2 = new Vector(5,5);
		
		for(int j=data.association.indexOf(image_association); 
		    j <= data.association.lastIndexOf(image_association);
		    j++) {
		    if(j != -1) {
			labels2.add(data.name.get(j));
			types2.add(data.type.get(j));
			values2.add(data.values.get(j));
		    }
		}	 

		// initialize the vertex to the default values for its type
		//
		//button.initializeConfig(labels2, values2, types2,
		//		image_association, data);
		
		// add subclass button to the vector
		//
		subparam.add(button);
		
		// attach an action listener to the button
		//
		button.setActionCommand(ALGORITHM_PARAM);
	    }

	    // do nothing if the type is image
	    //
	    else if (types.get(i).equals(ALGORITHM_IMAGE)) {
		values.add(v.get(i));
	    }

	    // If there is only one value given, set the default as the value
	    //
	    else {
		
		// add the defaults to the values vector
		//
		values.add(v.get(i));
	    }    
	}
    }

    // method: initializeConfigGen
    //
    // arguments:
    //   Vector n: (input) vector of algorithm names
    //   Vector v: (input) vector of algorithm values
    //   Vector t: (input) vector of algorithm data types
    //   String s: (input) algorithm immage association
    //   Data d: (input) algorithm data object
    // returns  : none
    //
    // initializes the configuration parameters of the algorithm vertex
    //
    public void initializeConfigGen(Vector n, Vector v, Vector t, 
				 String a, Data d) {
	
	// initialize data members
	//
	names = n;
	types = t;
	association = a;
	Data data = d;

	values = new Vector(5,5);
	//subparam = new Vector(2,1);

	for(int i=0; i < v.size(); i++) {

	    // if enumerated type, get the first value
	    //	
	    if(types.get(i).equals(ALGORITHM_ENUM)){
		Vector enum_values = (Vector)v.get(i);
		values.add(enum_values.get(0));
	    }

	    // add a default object with basic parameters here to begin with
	    // this still needs to be worked out properly
	    //
	    else if (types.get(i).equals(ALGORITHM_PARAM)) {
		values.add(v.get(i));
		max_subparam++;
		
		String image_name = null;
		String image_association= null;
		
		// tells the program which ALGORITHM it is looking to match
		//
		image_association = (String)values.get(i);

		// scans through the association until it finds the 
		// smallIcon key
		//
		for(int j=data.association.indexOf(image_association); 
		    j <= data.association.lastIndexOf(image_association);
		    j++) {
		    if(j != -1) {
			if(((String)(data.name.get(j))).equals(ALGORITHM_ICON_SMALL)) {
			    // sets the image_name to the value held in 
			    // small icon
			    //
			    image_name = (String)data.values.get(j);
			}
		    }
		}
		    
		// check to see if the file exists. If it does not exist,
		// use a default image
		//
		if(image_name != null){
		    File image_file = new File(image_name);
		    if (image_file.exists() == false)
			image_name = ALGORITHM_DEFAULT;
		}
		else {
		    image_name = ALGORITHM_DEFAULT;
		}
		
		image_name = GUI_PATH+"/lib/images/isip_transform_builder/icons/algorithm_00.gif";
		
		// create the icons for the config panel
		//
		ImageIcon icon = new ImageIcon(image_name);
		
		// create the button for the config panel
		//
		Vertex button = new Vertex(icon, ALGORITHM);
		button.association = image_association;
		
		// to simplify the creation, the data vectors will be trimmed 
		// to only include the ALGORITHM we're looking at and saved 
		// into these three vectors for use in a bit
		//
		Vector labels2 = new Vector(5,5);
		Vector types2 = new Vector(5,5);
		Vector values2 = new Vector(5,5);
		
		for(int j=data.association.indexOf(image_association); 
		    j <= data.association.lastIndexOf(image_association);
		    j++) {
		    if(j != -1) {
			labels2.add(data.name.get(j));
			types2.add(data.type.get(j));
			values2.add(data.values.get(j));
		    }
		}	 

		// initialize the vertex to the default values for its type
		//
		//button.initializeConfig(labels2, values2, types2,
		//		image_association, data);
		
		// add subclass button to the vector
		//
		subparam.add(button);
		
		// attach an action listener to the button
		//
		//xbutton.setActionCommand(ALGORITHM_CLASS);
		button.setActionCommand("param");
		//button.addActionListener(digraph);
	    }

	    // do nothing if the type is image
	    //
	    else if (types.get(i).equals(ALGORITHM_IMAGE)) {
		values.add(v.get(i));
	    }

	    // If there is only one value given, set the default as the value
	    //
	    else {
		
		// add the defaults to the values vector
		//
		values.add(v.get(i));
	    }    
	}
    }

    // ---------------------------------------------------
    //
    // class required methods
    //
    // ---------------------------------------------------

    // method: paintComponent
    //
    // arguments:
    //   Graphics g: (input) graphics object
    //
    // return: none
    //
    protected void paintComponent(Graphics g) {

	// set the background color of the vertex
	//
	switch (vertexType) {

	case ALGORITHM:
	    break;
	case CONTAINER:
	    break;
	default:
	    break;
	}

	// this call will paint the label and the focus
	//
	super.paintComponent(g); 
    }

    // method: paintBorder
    //
    // arguments:
    //    Graphics g: (input) graphics object
    //
    // return: none
    //
    protected void paintBorder(Graphics g) { 
	// not implemented
    }
}

//
// end of file















